
#ifndef  HAVE_DEFINE_H
#define HAVE_DEFINE_H

#include <glib-object.h>
#include <popt.h>

#include <sys/signal.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <crypt.h>
#include <ctype.h>
#include <dirent.h>
#include <fcntl.h>
#include <glib.h>
#include <grp.h>
#include <libintl.h>
#include <limits.h>
#include <locale.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <utime.h>

#include <user.h>
#include <entity.h>
#include <user_private.h>

#include <qmessagebox.h>
#include <qstringlist.h> 
#include <qptrlist.h> 

#define INVALID (-0x80000000)

#define REMOVE_HOME 			1
#define DONT_REMOVE_HOME 	0
#define REMOVE_GROUP			0
#define DONT_REMOVE_GROUP	1

#define	GROUP	1
#define	USER	2
#define	NONE	10
#define	 NOT_NUMBER	-11111111


class  RFAccount{

	public:	

	enum lu_entity_type	type;
	QString		name;
	QStringList	gr_mem; 
	QString		password;
	long		uid;
	long		gid;
	QString		gName;
	QString		gecos;
	QString		dir;
	QString		shell;
	QString		sp_pwdp;
	long		sp_lstchg;
	long		sp_min;
	long		sp_max;
	long		sp_warn;
	long		sp_inact;
	long		sp_expire;
	long		sp_flag;
	int		isLocked;

};

int RFVerifyCN( QString str );

int RFVerifyString( QString str );

int RFVerifyDir( QString str );

long RFVerifyLong( QString str );

void RFWarn(QString, QString, QWidget* form, QString info);

bool isSimple(const char * password);

gboolean lu_homedir_move(const char *oldhome, const char *directory,  struct lu_error **error);

gboolean lu_homedir_remove(const char *, struct lu_error ** );

/* Create a mail spool for the user. */
gboolean lu_mailspool_create_remove(struct lu_context *, struct lu_ent *,   gboolean );

/* Populate a user's home directory, copying data from a named skeleton
 * directory, setting all ownerships as given, and setting the mode of
 * the top-level directory as given. */
gboolean  lu_homedir_populate(const char *, const char *,  uid_t , gid_t , mode_t ,   struct lu_error **);

/* Send nscd an arbitrary signal. */
void	lu_signal_nscd(int );

/* Send nscd a SIGHUP. */
void	lu_hup_nscd();

void	LibGetAccount(struct lu_ent *, RFAccount*  );
//void	LibGetAccount(struct lu_ent *ent,  struct lu_context *ctx, RFAccount*  account);

void	LibGetAllAccounts( QPtrList<RFAccount>& );

int	LibAddNewUser(	const char* 	name,
			const char* 	gid,
			long 		uidNumber,
			const char* 	gecos,
			const char*	loginShell,
			const char*	homeDirectory,
			const char*	userPassword,
			const char*	cryptedUserPassword,
			int 		dont_create_group,
			int 		dont_create_home,
			int 		lock 
		);


int	LibDelUser(	const char*	user,
			int		remove_home,
			int		dont_remove_group
		);

int	LibDelGroup(const char * name);

int 	LibChangeGroupPropties(	const char*	group,
				long		gidNumber,
				const char* 	gid,
				const char* 	userPassword,
				const char* 	cryptedUserPassword,
				const char* 	addAdmins,
				const char* 	remAdmins,
				const char* 	addMembers,
				const char* 	remMembers,
				int 		lock,
				int 		unlock
		);

int 	LibChangeUserPropties(	const char*	user, 
				const char*	gecos,
				const char*	homeDirectory,
				int 		move_home,
				const char*	loginShell, 
				long 		uidNumber,
				long 		gidNumber,
				const char*	uid,
				const char*	userPassword,
				const char*	cryptedUserPassword,
				int 		lock,
				int 		unlock
		);

int	LibGetAllNames( QStringList& libNames, int type);

int 	LibAddNewGroup(  const char * name, long gidNumber, int system_account );

int	LibSetPassword( const char* name, int groupflag, const char* password, int is_crypted);

int	LibIsLocked( const char* name);
//int     LibIsLocked(struct lu_ent *ent, struct lu_context *ctx, const char* name);

int	LibRemovePwd( const char* name);

int 	LibGetGroupNameByID( long gidNumber, char name[32]);

long	LibGetGroupIDByName(const char* name );

long	LibGetUserIDByName(const char* name);

int	LibChangeAge( const char *user, long shadowExpire );

int	LibReBindUser( const char*user, const char*newName, QPtrList<RFAccount>& accounts);

int	LibFreeRelation( const char*user, RFAccount* account);

int	LibFreeRelation( const char*user, const char* group, QPtrList<RFAccount>& accounts);

#endif



